// Code generated by mockery v2.52.2. DO NOT EDIT.

package tissue

import (
	context "context"

	cell "gitlab.com/gitlab-com/gl-infra/ringctl/lib/cell"

	mock "github.com/stretchr/testify/mock"

	patch "gitlab.com/gitlab-com/gl-infra/ringctl/lib/patch"
)

// MockCellsStorage is an autogenerated mock type for the CellsStorage type
type MockCellsStorage struct {
	mock.Mock
}

type MockCellsStorage_Expecter struct {
	mock *mock.Mock
}

func (_m *MockCellsStorage) EXPECT() *MockCellsStorage_Expecter {
	return &MockCellsStorage_Expecter{mock: &_m.Mock}
}

// AddPatch provides a mock function with given fields: ctx, cluster, meta
func (_m *MockCellsStorage) AddPatch(ctx context.Context, cluster Cluster, meta *patch.Metadata) error {
	ret := _m.Called(ctx, cluster, meta)

	if len(ret) == 0 {
		panic("no return value specified for AddPatch")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, Cluster, *patch.Metadata) error); ok {
		r0 = rf(ctx, cluster, meta)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockCellsStorage_AddPatch_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'AddPatch'
type MockCellsStorage_AddPatch_Call struct {
	*mock.Call
}

// AddPatch is a helper method to define mock.On call
//   - ctx context.Context
//   - cluster Cluster
//   - meta *patch.Metadata
func (_e *MockCellsStorage_Expecter) AddPatch(ctx interface{}, cluster interface{}, meta interface{}) *MockCellsStorage_AddPatch_Call {
	return &MockCellsStorage_AddPatch_Call{Call: _e.mock.On("AddPatch", ctx, cluster, meta)}
}

func (_c *MockCellsStorage_AddPatch_Call) Run(run func(ctx context.Context, cluster Cluster, meta *patch.Metadata)) *MockCellsStorage_AddPatch_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(Cluster), args[2].(*patch.Metadata))
	})
	return _c
}

func (_c *MockCellsStorage_AddPatch_Call) Return(_a0 error) *MockCellsStorage_AddPatch_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockCellsStorage_AddPatch_Call) RunAndReturn(run func(context.Context, Cluster, *patch.Metadata) error) *MockCellsStorage_AddPatch_Call {
	_c.Call.Return(run)
	return _c
}

// DeletePatch provides a mock function with given fields: ctx, cluster, patchID
func (_m *MockCellsStorage) DeletePatch(ctx context.Context, cluster Cluster, patchID string) error {
	ret := _m.Called(ctx, cluster, patchID)

	if len(ret) == 0 {
		panic("no return value specified for DeletePatch")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, Cluster, string) error); ok {
		r0 = rf(ctx, cluster, patchID)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockCellsStorage_DeletePatch_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'DeletePatch'
type MockCellsStorage_DeletePatch_Call struct {
	*mock.Call
}

// DeletePatch is a helper method to define mock.On call
//   - ctx context.Context
//   - cluster Cluster
//   - patchID string
func (_e *MockCellsStorage_Expecter) DeletePatch(ctx interface{}, cluster interface{}, patchID interface{}) *MockCellsStorage_DeletePatch_Call {
	return &MockCellsStorage_DeletePatch_Call{Call: _e.mock.On("DeletePatch", ctx, cluster, patchID)}
}

func (_c *MockCellsStorage_DeletePatch_Call) Run(run func(ctx context.Context, cluster Cluster, patchID string)) *MockCellsStorage_DeletePatch_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(Cluster), args[2].(string))
	})
	return _c
}

func (_c *MockCellsStorage_DeletePatch_Call) Return(_a0 error) *MockCellsStorage_DeletePatch_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockCellsStorage_DeletePatch_Call) RunAndReturn(run func(context.Context, Cluster, string) error) *MockCellsStorage_DeletePatch_Call {
	_c.Call.Return(run)
	return _c
}

// GetPatch provides a mock function with given fields: ctx, cluster, patchID
func (_m *MockCellsStorage) GetPatch(ctx context.Context, cluster Cluster, patchID string) (*patch.Metadata, error) {
	ret := _m.Called(ctx, cluster, patchID)

	if len(ret) == 0 {
		panic("no return value specified for GetPatch")
	}

	var r0 *patch.Metadata
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, Cluster, string) (*patch.Metadata, error)); ok {
		return rf(ctx, cluster, patchID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, Cluster, string) *patch.Metadata); ok {
		r0 = rf(ctx, cluster, patchID)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*patch.Metadata)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, Cluster, string) error); ok {
		r1 = rf(ctx, cluster, patchID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockCellsStorage_GetPatch_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'GetPatch'
type MockCellsStorage_GetPatch_Call struct {
	*mock.Call
}

// GetPatch is a helper method to define mock.On call
//   - ctx context.Context
//   - cluster Cluster
//   - patchID string
func (_e *MockCellsStorage_Expecter) GetPatch(ctx interface{}, cluster interface{}, patchID interface{}) *MockCellsStorage_GetPatch_Call {
	return &MockCellsStorage_GetPatch_Call{Call: _e.mock.On("GetPatch", ctx, cluster, patchID)}
}

func (_c *MockCellsStorage_GetPatch_Call) Run(run func(ctx context.Context, cluster Cluster, patchID string)) *MockCellsStorage_GetPatch_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(Cluster), args[2].(string))
	})
	return _c
}

func (_c *MockCellsStorage_GetPatch_Call) Return(_a0 *patch.Metadata, _a1 error) *MockCellsStorage_GetPatch_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockCellsStorage_GetPatch_Call) RunAndReturn(run func(context.Context, Cluster, string) (*patch.Metadata, error)) *MockCellsStorage_GetPatch_Call {
	_c.Call.Return(run)
	return _c
}

// LastRing provides a mock function with given fields: ctx, cluster
func (_m *MockCellsStorage) LastRing(ctx context.Context, cluster Cluster) (int, error) {
	ret := _m.Called(ctx, cluster)

	if len(ret) == 0 {
		panic("no return value specified for LastRing")
	}

	var r0 int
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, Cluster) (int, error)); ok {
		return rf(ctx, cluster)
	}
	if rf, ok := ret.Get(0).(func(context.Context, Cluster) int); ok {
		r0 = rf(ctx, cluster)
	} else {
		r0 = ret.Get(0).(int)
	}

	if rf, ok := ret.Get(1).(func(context.Context, Cluster) error); ok {
		r1 = rf(ctx, cluster)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockCellsStorage_LastRing_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'LastRing'
type MockCellsStorage_LastRing_Call struct {
	*mock.Call
}

// LastRing is a helper method to define mock.On call
//   - ctx context.Context
//   - cluster Cluster
func (_e *MockCellsStorage_Expecter) LastRing(ctx interface{}, cluster interface{}) *MockCellsStorage_LastRing_Call {
	return &MockCellsStorage_LastRing_Call{Call: _e.mock.On("LastRing", ctx, cluster)}
}

func (_c *MockCellsStorage_LastRing_Call) Run(run func(ctx context.Context, cluster Cluster)) *MockCellsStorage_LastRing_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(Cluster))
	})
	return _c
}

func (_c *MockCellsStorage_LastRing_Call) Return(_a0 int, _a1 error) *MockCellsStorage_LastRing_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockCellsStorage_LastRing_Call) RunAndReturn(run func(context.Context, Cluster) (int, error)) *MockCellsStorage_LastRing_Call {
	_c.Call.Return(run)
	return _c
}

// ListCells provides a mock function with given fields: ctx, ring
func (_m *MockCellsStorage) ListCells(ctx context.Context, ring Ring) ([]*cell.Cell, error) {
	ret := _m.Called(ctx, ring)

	if len(ret) == 0 {
		panic("no return value specified for ListCells")
	}

	var r0 []*cell.Cell
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, Ring) ([]*cell.Cell, error)); ok {
		return rf(ctx, ring)
	}
	if rf, ok := ret.Get(0).(func(context.Context, Ring) []*cell.Cell); ok {
		r0 = rf(ctx, ring)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]*cell.Cell)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, Ring) error); ok {
		r1 = rf(ctx, ring)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockCellsStorage_ListCells_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'ListCells'
type MockCellsStorage_ListCells_Call struct {
	*mock.Call
}

// ListCells is a helper method to define mock.On call
//   - ctx context.Context
//   - ring Ring
func (_e *MockCellsStorage_Expecter) ListCells(ctx interface{}, ring interface{}) *MockCellsStorage_ListCells_Call {
	return &MockCellsStorage_ListCells_Call{Call: _e.mock.On("ListCells", ctx, ring)}
}

func (_c *MockCellsStorage_ListCells_Call) Run(run func(ctx context.Context, ring Ring)) *MockCellsStorage_ListCells_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(Ring))
	})
	return _c
}

func (_c *MockCellsStorage_ListCells_Call) Return(_a0 []*cell.Cell, _a1 error) *MockCellsStorage_ListCells_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockCellsStorage_ListCells_Call) RunAndReturn(run func(context.Context, Ring) ([]*cell.Cell, error)) *MockCellsStorage_ListCells_Call {
	_c.Call.Return(run)
	return _c
}

// ListPatches provides a mock function with given fields: ctx, cluster
func (_m *MockCellsStorage) ListPatches(ctx context.Context, cluster Cluster) ([]*patch.Metadata, error) {
	ret := _m.Called(ctx, cluster)

	if len(ret) == 0 {
		panic("no return value specified for ListPatches")
	}

	var r0 []*patch.Metadata
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, Cluster) ([]*patch.Metadata, error)); ok {
		return rf(ctx, cluster)
	}
	if rf, ok := ret.Get(0).(func(context.Context, Cluster) []*patch.Metadata); ok {
		r0 = rf(ctx, cluster)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]*patch.Metadata)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, Cluster) error); ok {
		r1 = rf(ctx, cluster)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockCellsStorage_ListPatches_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'ListPatches'
type MockCellsStorage_ListPatches_Call struct {
	*mock.Call
}

// ListPatches is a helper method to define mock.On call
//   - ctx context.Context
//   - cluster Cluster
func (_e *MockCellsStorage_Expecter) ListPatches(ctx interface{}, cluster interface{}) *MockCellsStorage_ListPatches_Call {
	return &MockCellsStorage_ListPatches_Call{Call: _e.mock.On("ListPatches", ctx, cluster)}
}

func (_c *MockCellsStorage_ListPatches_Call) Run(run func(ctx context.Context, cluster Cluster)) *MockCellsStorage_ListPatches_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(Cluster))
	})
	return _c
}

func (_c *MockCellsStorage_ListPatches_Call) Return(_a0 []*patch.Metadata, _a1 error) *MockCellsStorage_ListPatches_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockCellsStorage_ListPatches_Call) RunAndReturn(run func(context.Context, Cluster) ([]*patch.Metadata, error)) *MockCellsStorage_ListPatches_Call {
	_c.Call.Return(run)
	return _c
}

// Update provides a mock function with given fields: ctx, ring, cells, action, commitMsg
func (_m *MockCellsStorage) Update(ctx context.Context, ring Ring, cells []*cell.Cell, action CellsAction, commitMsg string) error {
	ret := _m.Called(ctx, ring, cells, action, commitMsg)

	if len(ret) == 0 {
		panic("no return value specified for Update")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, Ring, []*cell.Cell, CellsAction, string) error); ok {
		r0 = rf(ctx, ring, cells, action, commitMsg)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockCellsStorage_Update_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Update'
type MockCellsStorage_Update_Call struct {
	*mock.Call
}

// Update is a helper method to define mock.On call
//   - ctx context.Context
//   - ring Ring
//   - cells []*cell.Cell
//   - action CellsAction
//   - commitMsg string
func (_e *MockCellsStorage_Expecter) Update(ctx interface{}, ring interface{}, cells interface{}, action interface{}, commitMsg interface{}) *MockCellsStorage_Update_Call {
	return &MockCellsStorage_Update_Call{Call: _e.mock.On("Update", ctx, ring, cells, action, commitMsg)}
}

func (_c *MockCellsStorage_Update_Call) Run(run func(ctx context.Context, ring Ring, cells []*cell.Cell, action CellsAction, commitMsg string)) *MockCellsStorage_Update_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(Ring), args[2].([]*cell.Cell), args[3].(CellsAction), args[4].(string))
	})
	return _c
}

func (_c *MockCellsStorage_Update_Call) Return(_a0 error) *MockCellsStorage_Update_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockCellsStorage_Update_Call) RunAndReturn(run func(context.Context, Ring, []*cell.Cell, CellsAction, string) error) *MockCellsStorage_Update_Call {
	_c.Call.Return(run)
	return _c
}

// UpdatePatchStatus provides a mock function with given fields: ctx, cluster, meta
func (_m *MockCellsStorage) UpdatePatchStatus(ctx context.Context, cluster Cluster, meta *patch.Metadata) error {
	ret := _m.Called(ctx, cluster, meta)

	if len(ret) == 0 {
		panic("no return value specified for UpdatePatchStatus")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, Cluster, *patch.Metadata) error); ok {
		r0 = rf(ctx, cluster, meta)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockCellsStorage_UpdatePatchStatus_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'UpdatePatchStatus'
type MockCellsStorage_UpdatePatchStatus_Call struct {
	*mock.Call
}

// UpdatePatchStatus is a helper method to define mock.On call
//   - ctx context.Context
//   - cluster Cluster
//   - meta *patch.Metadata
func (_e *MockCellsStorage_Expecter) UpdatePatchStatus(ctx interface{}, cluster interface{}, meta interface{}) *MockCellsStorage_UpdatePatchStatus_Call {
	return &MockCellsStorage_UpdatePatchStatus_Call{Call: _e.mock.On("UpdatePatchStatus", ctx, cluster, meta)}
}

func (_c *MockCellsStorage_UpdatePatchStatus_Call) Run(run func(ctx context.Context, cluster Cluster, meta *patch.Metadata)) *MockCellsStorage_UpdatePatchStatus_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(Cluster), args[2].(*patch.Metadata))
	})
	return _c
}

func (_c *MockCellsStorage_UpdatePatchStatus_Call) Return(_a0 error) *MockCellsStorage_UpdatePatchStatus_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockCellsStorage_UpdatePatchStatus_Call) RunAndReturn(run func(context.Context, Cluster, *patch.Metadata) error) *MockCellsStorage_UpdatePatchStatus_Call {
	_c.Call.Return(run)
	return _c
}

// UpdateWithPatch provides a mock function with given fields: ctx, cluster, _a2, cells, commitMsg
func (_m *MockCellsStorage) UpdateWithPatch(ctx context.Context, cluster Cluster, _a2 *patch.Metadata, cells []*cell.Cell, commitMsg string) error {
	ret := _m.Called(ctx, cluster, _a2, cells, commitMsg)

	if len(ret) == 0 {
		panic("no return value specified for UpdateWithPatch")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, Cluster, *patch.Metadata, []*cell.Cell, string) error); ok {
		r0 = rf(ctx, cluster, _a2, cells, commitMsg)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockCellsStorage_UpdateWithPatch_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'UpdateWithPatch'
type MockCellsStorage_UpdateWithPatch_Call struct {
	*mock.Call
}

// UpdateWithPatch is a helper method to define mock.On call
//   - ctx context.Context
//   - cluster Cluster
//   - _a2 *patch.Metadata
//   - cells []*cell.Cell
//   - commitMsg string
func (_e *MockCellsStorage_Expecter) UpdateWithPatch(ctx interface{}, cluster interface{}, _a2 interface{}, cells interface{}, commitMsg interface{}) *MockCellsStorage_UpdateWithPatch_Call {
	return &MockCellsStorage_UpdateWithPatch_Call{Call: _e.mock.On("UpdateWithPatch", ctx, cluster, _a2, cells, commitMsg)}
}

func (_c *MockCellsStorage_UpdateWithPatch_Call) Run(run func(ctx context.Context, cluster Cluster, _a2 *patch.Metadata, cells []*cell.Cell, commitMsg string)) *MockCellsStorage_UpdateWithPatch_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(Cluster), args[2].(*patch.Metadata), args[3].([]*cell.Cell), args[4].(string))
	})
	return _c
}

func (_c *MockCellsStorage_UpdateWithPatch_Call) Return(_a0 error) *MockCellsStorage_UpdateWithPatch_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockCellsStorage_UpdateWithPatch_Call) RunAndReturn(run func(context.Context, Cluster, *patch.Metadata, []*cell.Cell, string) error) *MockCellsStorage_UpdateWithPatch_Call {
	_c.Call.Return(run)
	return _c
}

// NewMockCellsStorage creates a new instance of MockCellsStorage. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockCellsStorage(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockCellsStorage {
	mock := &MockCellsStorage{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
